#!/usr/bin/python
# -*- coding: utf-8 -*-

import string, xbmc, xbmcgui, xbmcplugin, xbmcaddon
import os, cookielib, urllib, urllib2, time
addon = xbmcaddon.Addon(id='plugin.video.pazl2.tv')
__settings__ = xbmcaddon.Addon(id='plugin.video.pazl2.tv')
#-----------------------------------------

icon = ""
serv_id = '23'
siteUrl = 'proxytv.ru'
httpSiteUrl = 'http://' + siteUrl
sid_file = os.path.join(xbmc.translatePath('special://temp/'), siteUrl+'.sid')

cj = cookielib.FileCookieJar(sid_file) 
hr  = urllib2.HTTPCookieProcessor(cj) 
opener = urllib2.build_opener(hr) 
urllib2.install_opener(opener) 

def fs(s):return s.decode('windows-1251').encode('utf-8')
def ru(x):return unicode(x,'utf8', 'ignore')
def xt(x):return xbmc.translatePath(x)

def CRC32(buf):
		import binascii
		buf = (binascii.crc32(buf) & 0xFFFFFFFF)
		return str("%08X" % buf)

def showMessage(heading, message, times = 3000):
	xbmc.executebuiltin('XBMC.Notification("%s", "%s", %s, "%s")'%(heading, message, times, icon))

def getURL(url, Referer = httpSiteUrl):
	req = urllib2.Request(url)
	req.add_header('User-Agent', 'Opera/10.60 (X11; openSUSE 11.3/Linux i686; U; ru) Presto/2.6.30 Version/10.60')
	req.add_header('Accept', 'text/html, application/xml, application/xhtml+xml, */*')
	req.add_header('Accept-Language', 'ru,en;q=0.9')
	req.add_header('Referer', Referer)
	response = urllib2.urlopen(req)
	link=response.read()
	response.close()
	return link

def POST(target, post=None, referer='http://pazl.tv'):
	#print target
	try:
		req = urllib2.Request(url = target, data = post)
		req.add_header('User-Agent', 'Mozilla/4.0 (compatible; MSIE 8.0; Windows NT 5.1; Trident/4.0; Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1; SV1) ; .NET CLR 1.1.4322; .NET CLR 2.0.50727; .NET CLR 3.0.4506.2152; .NET CLR 3.5.30729; .NET4.0C)')
		#req.add_header('X-Requested-With', 'XMLHttpRequest')
		req.add_header('Content-Type', 'application/x-www-form-urlencoded')
		resp = urllib2.urlopen(req)
		#print resp.info()
		http = resp.read()
		resp.close()
		return http
	except Exception, e:
		print e
		return ''

def mfindal(http, ss, es):
	L=[]
	while http.find(es)>0:
		s=http.find(ss)
		e=http.find(es)
		i=http[s:e]
		L.append(i)
		http=http[e+2:]
	return L

def mfind(t,s,e):
	r=t[t.find(s)+len(s):]
	r2=r[:r.find(e)]
	return r2

def lower(t):
	RUS={"А":"а", "Б":"б", "В":"в", "Г":"г", "Д":"д", "Е":"е", "Ё":"ё", "Ж":"ж", "З":"з", "И":"и", "Й":"й", "К":"к", "Л":"л", "М":"м", "Н":"н", "О":"о", "П":"п", "Р":"р", "С":"с", "Т":"т", "У":"у", "Ф":"ф", "Х":"х", "Ц":"ц", "Ч":"ч", "Ш":"ш", "Щ":"щ", "Ъ":"ъ", "Ы":"ы", "Ь":"ь", "Э":"э", "Ю":"ю", "Я":"я"}
	for i in range (65,90):
		t=t.replace(chr(i),chr(i+32))
	for i in RUS.keys():
		t=t.replace(i,RUS[i])
	return t

def upper(t):
	RUS={"А":"а", "Б":"б", "В":"в", "Г":"г", "Д":"д", "Е":"е", "Ё":"ё", "Ж":"ж", "З":"з", "И":"и", "Й":"й", "К":"к", "Л":"л", "М":"м", "Н":"н", "О":"о", "П":"п", "Р":"р", "С":"с", "Т":"т", "У":"у", "Ф":"ф", "Х":"х", "Ц":"ц", "Ч":"ч", "Ш":"ш", "Щ":"щ", "Ъ":"ъ", "Ы":"ы", "Ь":"ь", "Э":"э", "Ю":"ю", "Я":"я"}
	for i in RUS.keys():
		t=t.replace(RUS[i],i)
	for i in range (65,90):
		t=t.replace(chr(i+32),chr(i))
	return t

def get_id(name):
	import xid
	xmlid=xid.xmlid
	name=lower(name).replace(" (+1)","").replace(" (+2)","").replace(" (+3)","").replace(" (+4)","").replace(" (+5)","").replace(" (+6)","").replace(" (+7)","").replace(" (резерв)","").strip()
	try:
		id=xmlid[name].replace("ttv","")
	except: 
		print name
		id=''
	return id

def save_channels(n, L):
		ns=str(n)
		fp=xbmc.translatePath(os.path.join(addon.getAddonInfo('path'), 'Channels'+ns+'.py'))
		fl = open(fp, "w")
		fl.write('# -*- coding: utf-8 -*-\n')
		fl.write('Channels=[\n')
		for i in L:
			fl.write(repr(i)+',\n')
		fl.write(']\n')
		fl.write('tm='+str(time.time())+'\n')
		#fl.write('set='+get_set()+'\n')
		fl.close()

def get_cnl(s):
		print s
		fp=xbmc.translatePath(os.path.join(addon.getAddonInfo('path'), 'Channels23_'+s+'.py'))
		fl = open(fp, "r")
		t=fl.read()
		fl.close()
		L=eval(mfind(t,'Channels=',']')+']')
		return L

def uptm(s):
		fp=xbmc.translatePath(os.path.join(addon.getAddonInfo('path'), 'Channels23_'+s+'.py'))
		fl = open(fp, "r")
		t=fl.read()
		fl.close()
		tm=eval(mfind(t,'tm=','.')+'.00')
		if time.time()-tm > 7200: return True
		else:                     return False

def get_set():
		fp=xbmc.translatePath(os.path.join(xbmc.translatePath("special://masterprofile/"),"addon_data","plugin.video.pazl2.tv", 'settings.xml'))
		fl = open(fp, "r")
		t=fl.read()
		fl.close()
		L=t.splitlines()
		r=''
		for j in range (len(Lprov)):
			for i in L:
				if '<setting id="s23_'+str(j) in i:
					if 'true' in i: r+=str(j)
		return r

def get_rpov():
	target='http://proxytv.ru/iptv/php/srch.php'
	post='udpxyaddr=plist'
	p = POST(target, post)
	L=[]
	for i in p.splitlines():
		if '<img alt' in i:
			prov = mfind(i,'плейлист "','"')
			print prov
			L.append(prov)
	return L

Lprov=[
	'Aist',
	'Bes',
	'Briz',
	'Didgital',
	'Elite',
	'Garant',
	'Lada',
	'Optik',
	'Novotel',
	'Redkom',
	'RostNSK',
	'Tauer',
	'Zapsib',
	'Vladnet']


class PZL:
	def __init__(self):
		#print '==init=='
		#try:
		#	from Channels23 import set
		#	if set!=get_set(): self.Canals()
		#except:
		#	pass
		
		#try:
		#	from Channels23 import tm
		#	if time.time()-tm > 7200: self.Canals()
		#except:
		pass

	def Streams(self, url):
		serv = mfind(url,':','-')
		#if uptm(serv): self.Canals(serv)
		
		Channels = get_cnl(serv)
		id = url[url.find('-')+1:]
		
		for i in Channels:
			if id == i['id']: lnk=i['cid']
		return [lnk,]

	def Canals(self, ul=''):
		print 'обновление proxytv'
		if ul=='':
			Ln=[]
			for pn in range(len(Lprov)):
				if __settings__.getSetting("s23_"+str(pn+1)) == 'true': 
					Ln.append(Lprov[pn])
		else: Ln=[ul,]
		LL=[]
		for n in Ln:
			print n
			L4=[]
			target='http://proxytv.ru/iptv/php/srch.php'
			post='udpxyaddr=pl%3A+'+n
			p = POST(target, post)
			p = p.replace('#EXTINF','\n#EXTINF')
			L=[]
			for i in p.splitlines():
				if '#EXTINF' in i:
					title = mfind(i, '<b>', '<')
					cid = mfind(i, '<br>', '<')
					title=title.replace(" (резерв)","").replace('Резерв 1','').replace('Резерв 2','').replace('Резерв 3','').replace('(16:9)','').replace('(4:3)','').replace('[LQ]','').replace('(allfon)','').replace('(alfabass-tv)','').replace('(PlayList 24)','').replace('(рег)','').replace('  ',' ').strip()
					url='proxytv:'+n+"-"+CRC32(title)
					LL.append({'url':url, 'img':'', 'title':title, 'group':''})
					L4.append({'cid':cid, 'id':CRC32(title)})
			if L4!=[]: save_channels(serv_id+'_'+n, L4)
			else: print ('Не удалось загрузить '+n) #showMessage('proxytv', 'Не удалось загрузить '+n, times = 3000)
			
		if LL!=[]: save_channels(serv_id, LL)
		return LL

